# CrazyHTTPd : Light weight Web Server coded in Python
# (c) Chris Dorman, 2012-2013 <cdorm245@gmail.com>
# (c) Stephen C Phillips (sockets)
# License : GPLv2 +

import socket
import re
import select
 
# Standard socket stuff:
host = '' #Leave this blank
port = 80
sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
version = 1.2
sock.bind((host, port))
sock.listen(1)  
 
# listen to requests until loop is interupted
print "Starting CrazyHTTPd..." # Show that the HTTPd server is starting
while True:
    csock, caddr = sock.accept()
    print "Connection from: " + `caddr` # Show what IP is connecting to the server
    # patch to kill DoSS Attacks (Timeout)
    csock.setblocking(0)
    ready = select.select([csock], [], [], 2)
    if ready[0]:
        req = csock.recv(4128) # Four 4MB max load
    else:
        req = ""
    #req = csock.recv(1024000) # Recieve File Requests
    strip_down = re.compile('GET /(\S+)( .*|$)')
    get = strip_down.match(req)
    header_200 = 'HTTP/1.1 200 "Ok"'
    server = 'Server: CrazyHTTPd'
    # different content types
    content_html = 'Content-Type: text/html' 
    content_css = 'Content-Type: text/css'
    content_jpg = 'Content-Type: image/jpg'
    content_png = 'Content-Type: image/png'
    content_gif = 'Content-Type: image/gif'
    content_tar = 'Content-Type: application/x-tar'
    content_zip = 'Content-Type: application/zip'
    content_unknown = 'Content-Type: octet-stream'
    if req.find('GET') !=-1:    
        try:
            with open(get.group(1)): pass # Check to see if file exists. Added to fix Crash.
            index = get.group(1)
            #
            # Check FIle Extention to set Content-Type
            #
            if index.endswith('.html'):
                print "Sending Packets (Default)"
                send_index = open('http/'+index, 'r').read()
                csock.sendall(header_200+'\n'
                                +server+'\n'
                                +content_html+'\n\n'
                                +send_index)
            if index.endswith('.txt'):
                print "Sending Packets (Requested Text File)"
                send_index = open('http/'+index, 'r').read()
                csock.sendall(header_200+'\n'
                                +server+'\n\n'
                                +send_index)
            if index.endswith('.css'):  
                print "Sending Packets (CSS Stylesheet requested)"
                send_index = open('http/'+index, 'r').read()
                csock.sendall(header_200+'\n'
                                +server+'\n'
								+content_css+'\n\n'
                                +send_index)
            if index.endswith('.png'):  
                print "Sending Packets (PNG Image requested)"
                send_index = open('http/'+index, 'r').read()
                csock.sendall(header_200+'\n'
                                +server+'\n'
								+content_png+'\n\n'
                                +send_index)
            if index.endswith('.jpg'):  
                print "Sending Packets (JPEG Image requested)"
                send_index = open('http/'+index, 'r').read()
                csock.sendall(header_200+'\n'
                                +server+'\n'
								+content_jpg+'\n\n'
                                +send_index)
            if index.endswith('.jpeg'):  
                print "Sending Packets (JPEG Image requested)"
                send_index = open('http/'+index, 'r').read()
                csock.sendall(header_200+'\n'
                                +server+'\n'
								+content_jpg+'\n\n'
                                +send_index)
            if index.endswith('.gif'):  
                print "Sending Packets (gif Image requested)"
                send_index = open('http/'+index, 'r').read()
                csock.sendall(header_200+'\n'
                                +server+'\n'
								+content_gif+'\n\n'
                                +send_index)
            if index.endswith('.zip'):  
                print "Sending Packets (ZIP requested)"
                send_index = open('http/'+index, 'r').read()
                csock.sendall(header_200+'\n'
                                +server+'\n'
								+content_zip+'\n\n'
                                +send_index)
            if index.endswith('.tgz'):  
                print "Sending Packets (Archive requested)"
                send_index = open('http/'+index, 'r').read()
                csock.sendall(header_200+'\n'
                                +server+'\n'
								+content_tar+'\n\n'
                                +send_index)
            if index.endswith('.gz'):  
                print "Sending Packets (Archive requested)"
                send_index = open('http/'+index, 'r').read()
                csock.sendall(header_200+'\n'
                                +server+'\n'
								+content_tar+'\n\n'
                                +send_index)
            if index.endswith('.tar'):  
                print "Sending Packets (Archive requested)"
                send_index = open('http/'+index, 'r').read()
                csock.sendall(header_200+'\n'
                                +server+'\n'
								+content_tar+'\n\n'
                                +send_index)
            if index.endswith('*'):  
                print "Sending Packets (Unknown requested)"
                send_index = open('http/'+index, 'r').read()
                csock.sendall(header_200+'\n'
                                +server+'\n'
								+content_unknown+'\n\n'
                                +send_index)                             
        except (AttributeError, IOError): # If File is not Found, redirects to index.html
        # Attribute added for if the index.html is not specified in the URL
            try:
                with open('http/index.html'): pass
                csock.sendall(header_200+'\n'
                                +server+'\n'
                                +content_html+'\n\n'
                                +open('http/index.html', 'r').read())
            except IOError:    # If Index Is not Found, Tell the Viewer
                print "Could Not Send Data Packets"
                csock.sendall(header_200+'\n'
                                +server+'\n'
                                +content_html+
                                '\n\n<html><title>Error: 404</title><h1><b>404: Not Found</b></h1></html>')
    csock.close()
